Class Http1Config.BuilderBase<BUILDER extends Http1Config.BuilderBase<BUILDER, PROTOTYPE>, PROTOTYPE extends Http1Config>
java.lang.Object
io.helidon.http.HttpConfig.BuilderBase<BUILDER, PROTOTYPE>
io.helidon.webserver.http1.Http1Config.BuilderBase<BUILDER, PROTOTYPE>
- Type Parameters:
BUILDER- type of the builder extending this abstract builderPROTOTYPE- type of the prototype interface that would be built byPrototype.Builder.buildPrototype()
- All Implemented Interfaces:
Prototype.Builder<BUILDER, PROTOTYPE>, ConfigBuilderSupport.ConfiguredBuilder<BUILDER, PROTOTYPE>
- Direct Known Subclasses:
Http1Config.Builder
- Enclosing interface:
Http1Config
public abstract static class Http1Config.BuilderBase<BUILDER extends Http1Config.BuilderBase<BUILDER, PROTOTYPE>, PROTOTYPE extends Http1Config>
extends HttpConfig.BuilderBase<BUILDER, PROTOTYPE>
implements ConfigBuilderSupport.ConfiguredBuilder<BUILDER, PROTOTYPE>
Fluent API builder base for
Http1Config.-
Nested Class Summary
Nested ClassesModifier and TypeClassDescriptionprotected static classGenerated implementation of the prototype, can be extended by descendant prototype implementations.Nested classes/interfaces inherited from class HttpConfig.BuilderBase
HttpConfig.BuilderBase.HttpConfigImplModifier and TypeClassDescriptionprotected static classGenerated implementation of the prototype, can be extended by descendant prototype implementations. -
Constructor Summary
Constructors -
Method Summary
Modifier and TypeMethodDescriptionaddReceiveListener(Http1ConnectionListener receiveListener) Connection receive event listeners for HTTP/1.1.addReceiveListeners(List<? extends Http1ConnectionListener> receiveListeners) Connection receive event listeners for HTTP/1.1.addSendListener(Http1ConnectionListener sendListener) Connection send event listeners for HTTP/1.1.addSendListeners(List<? extends Http1ConnectionListener> sendListeners) Connection send event listeners for HTTP/1.1.altSvc()ExplicitAlt-Svcadvertisement.ExplicitAlt-Svcadvertisement.altSvc(AltSvcConfig altSvc) ExplicitAlt-Svcadvertisement.altSvc(Consumer<AltSvcConfig.Builder> consumer) ExplicitAlt-Svcadvertisement.Clear existing value of altSvc.Clear all receiveListeners.Clear all sendListeners.A single receive listener, this value is computed.compositeReceiveListener(Http1ConnectionListener compositeReceiveListener) A single receive listener, this value is computed.A single send listener, this value is computed.compositeSendListener(Http1ConnectionListener compositeSendListener) A single send listener, this value is computed.Update builder from configuration (node of this type).booleanWhen true WebServer answers to expect continue with 100 continue immediately, not waiting for user to actually request the data.continueImmediately(boolean continueImmediately) When true WebServer answers to expect continue with 100 continue immediately, not waiting for user to actually request the data.from(Http1Config prototype) Update this builder from an existing prototype instance.from(Http1Config.BuilderBase<?, ?> builder) Update this builder from an existing prototype builder instance.intMaximum size of received headers in bytes, which must be greater than0.maxHeadersSize(int maxHeadersSize) Maximum size of received headers in bytes, which must be greater than0.intMaximal size of received HTTP prologue (GET /path HTTP/1.1).maxPrologueLength(int maxPrologueLength) Maximal size of received HTTP prologue (GET /path HTTP/1.1).name()Name of this configuration, in most cases the same asHttp1Config.type().Name of this configuration, in most cases the same asHttp1Config.type().protected voidHandles providers and decorators.Connection receive event listeners for HTTP/1.1.receiveListeners(List<? extends Http1ConnectionListener> receiveListeners) Connection receive event listeners for HTTP/1.1.booleanDeprecated, for removal: This API element is subject to removal in a future version.receiveLog(boolean receiveLog) Deprecated, for removal: This API element is subject to removal in a future version.Requested URI discovery settings.requestedUriDiscovery(RequestedUriDiscoveryContext requestedUriDiscovery) Requested URI discovery settings.Requested URI discovery settings.requestedUriDiscovery(Supplier<? extends RequestedUriDiscoveryContext> supplier) Requested URI discovery settings.Connection send event listeners for HTTP/1.1.sendListeners(List<? extends Http1ConnectionListener> sendListeners) Connection send event listeners for HTTP/1.1.booleansendLog()Deprecated, for removal: This API element is subject to removal in a future version.sendLog(boolean sendLog) Deprecated, for removal: This API element is subject to removal in a future version.toString()booleanWhether to validate path characters and HTTP/1.1 request-target forms.validatePath(boolean validatePath) Whether to validate path characters and HTTP/1.1 request-target forms.booleanDisables query and fragment syntax validation when set tofalse; intended only for closed systems receiving trusted, valid request targets, as behavior for invalid input is unspecified.validatePrologue(boolean validatePrologue) Disables query and fragment syntax validation when set tofalse; intended only for closed systems receiving trusted, valid request targets, as behavior for invalid input is unspecified.protected voidValidates required properties.Methods inherited from class HttpConfig.BuilderBase
config, from, from, log, log, log, log, maxBufferedEntitySize, maxBufferedEntitySize, validateRequestHeaders, validateRequestHeaders, validateResponseHeaders, validateResponseHeadersModifier and TypeMethodDescriptionconfig()Configuration used to configure this instance.from(HttpConfig prototype) Update this builder from an existing prototype instance.from(HttpConfig.BuilderBase<?, ?> builder) Update this builder from an existing prototype builder instance.log()HTTP Log configuration.log(HttpLogConfig log) HTTP Log configuration.log(Consumer<HttpLogConfig.Builder> consumer) HTTP Log configuration.log(Supplier<? extends HttpLogConfig> supplier) HTTP Log configuration.Configure the maximum size allowed for an entity that can be explicitly buffered by the application by callingio.helidon.http.media.ReadableEntity.buffer().maxBufferedEntitySize(Size maxBufferedEntitySize) Configure the maximum size allowed for an entity that can be explicitly buffered by the application by callingio.helidon.http.media.ReadableEntity.buffer().booleanWhether to validate request headers.validateRequestHeaders(boolean validateRequestHeaders) Whether to validate request headers.booleanWhether to validate response headers.validateResponseHeaders(boolean validateResponseHeaders) Whether to validate response headers.Methods inherited from class Object
clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, waitMethods inherited from interface Prototype.Builder
buildPrototype, self
-
Constructor Details
-
BuilderBase
protected BuilderBase()Protected to support extensibility.
-
-
Method Details
-
from
Update this builder from an existing prototype instance. This method disables automatic service discovery.- Parameters:
prototype- existing prototype to update this builder from- Returns:
- updated builder instance
-
from
Update this builder from an existing prototype builder instance.- Parameters:
builder- existing builder prototype to update this builder from- Returns:
- updated builder instance
-
config
Update builder from configuration (node of this type). If a value is present in configuration, it would override currently configured values.- Specified by:
configin interfaceConfigBuilderSupport.ConfiguredBuilder<BUILDER extends Http1Config.BuilderBase<BUILDER, PROTOTYPE>, PROTOTYPE extends Http1Config>- Overrides:
configin classHttpConfig.BuilderBase<BUILDER extends Http1Config.BuilderBase<BUILDER, PROTOTYPE>, PROTOTYPE extends Http1Config>- Parameters:
config- configuration instance used to obtain values to update this builder- Returns:
- updated builder instance
-
name
Name of this configuration, in most cases the same asHttp1Config.type().- Parameters:
name- name of this configuration- Returns:
- updated builder instance
- See Also:
-
maxPrologueLength
Maximal size of received HTTP prologue (GET /path HTTP/1.1).- Parameters:
maxPrologueLength- maximal size in bytes- Returns:
- updated builder instance
- See Also:
-
maxHeadersSize
Maximum size of received headers in bytes, which must be greater than0. Defaults to16384.This override preserves generated
Http1Config.BuilderBasebinary compatibility.- Overrides:
maxHeadersSizein classHttpConfig.BuilderBase<BUILDER extends Http1Config.BuilderBase<BUILDER, PROTOTYPE>, PROTOTYPE extends Http1Config>- Parameters:
maxHeadersSize- maximum headers size- Returns:
- updated builder instance
- See Also:
-
validatePrologue
Disables query and fragment syntax validation when set tofalse; intended only for closed systems receiving trusted, valid request targets, as behavior for invalid input is unspecified. Validation of path is controlled byvalidatePath().- Parameters:
validatePrologue- whether to validate prologue query and fragment- Returns:
- updated builder instance
- See Also:
-
validatePath
Whether to validate path characters and HTTP/1.1 request-target forms.- Parameters:
validatePath- whether to validate path- Returns:
- updated builder instance
- See Also:
-
continueImmediately
When true WebServer answers to expect continue with 100 continue immediately, not waiting for user to actually request the data.- Parameters:
continueImmediately- iftrueanswer with 100 continue immediately after expect continue- Returns:
- updated builder instance
- See Also:
-
requestedUriDiscovery
Requested URI discovery settings.- Parameters:
requestedUriDiscovery- settings for computing the requested URI- Returns:
- updated builder instance
- See Also:
-
requestedUriDiscovery
Requested URI discovery settings.- Parameters:
consumer- consumer of builder of settings for computing the requested URI- Returns:
- updated builder instance
- See Also:
-
requestedUriDiscovery
Requested URI discovery settings.- Parameters:
supplier- supplier of settings for computing the requested URI- Returns:
- updated builder instance
- See Also:
-
clearSendListeners
Clear all sendListeners.- Returns:
- updated builder instance
- See Also:
-
sendListeners
Connection send event listeners for HTTP/1.1.- Parameters:
sendListeners- send event listeners- Returns:
- updated builder instance
- See Also:
-
addSendListeners
Connection send event listeners for HTTP/1.1.- Parameters:
sendListeners- send event listeners- Returns:
- updated builder instance
- See Also:
-
addSendListener
Connection send event listeners for HTTP/1.1.- Parameters:
sendListener- add single send event listeners- Returns:
- updated builder instance
- See Also:
-
clearReceiveListeners
Clear all receiveListeners.- Returns:
- updated builder instance
- See Also:
-
receiveListeners
Connection receive event listeners for HTTP/1.1.- Parameters:
receiveListeners- receive event listeners- Returns:
- updated builder instance
- See Also:
-
addReceiveListeners
Connection receive event listeners for HTTP/1.1.- Parameters:
receiveListeners- receive event listeners- Returns:
- updated builder instance
- See Also:
-
addReceiveListener
Connection receive event listeners for HTTP/1.1.- Parameters:
receiveListener- add single receive event listeners- Returns:
- updated builder instance
- See Also:
-
clearAltSvc
Clear existing value of altSvc.- Returns:
- updated builder instance
- See Also:
-
altSvc
-
altSvc
ExplicitAlt-Svcadvertisement.- Parameters:
altSvc- prototype of alternative service advertisement- Returns:
- updated builder instance
- See Also:
-
altSvc
ExplicitAlt-Svcadvertisement.- Parameters:
consumer- consumer of builder of alternative service advertisement- Returns:
- updated builder instance
- See Also:
-
compositeSendListener
A single send listener, this value is computed.- Parameters:
compositeSendListener- send listener- Returns:
- updated builder instance
- See Also:
-
compositeReceiveListener
A single receive listener, this value is computed.- Parameters:
compositeReceiveListener- receive listener- Returns:
- updated builder instance
- See Also:
-
receiveLog
Deprecated, for removal: This API element is subject to removal in a future version.Logging of received packets. Uses trace and debug levels on logger ofHttp1LoggingConnectionListenerwith suffix of.recv`.- Parameters:
receiveLog-trueif logging should be enabled for received packets,falseif no logging should be done- Returns:
- updated builder instance
- See Also:
-
sendLog
Deprecated, for removal: This API element is subject to removal in a future version.Logging of sent packets. Uses trace and debug levels on logger ofHttp1LoggingConnectionListenerwith suffix of.send`.- Parameters:
sendLog-trueif logging should be enabled for sent packets,falseif no logging should be done- Returns:
- updated builder instance
- See Also:
-
name
Name of this configuration, in most cases the same asHttp1Config.type().- Returns:
- name of this configuration
-
maxPrologueLength
public int maxPrologueLength()Maximal size of received HTTP prologue (GET /path HTTP/1.1).- Returns:
- maximal size in bytes
-
maxHeadersSize
public int maxHeadersSize()Maximum size of received headers in bytes, which must be greater than0. Defaults to16384.This override preserves generated
Http1Config.BuilderBasebinary compatibility.- Overrides:
maxHeadersSizein classHttpConfig.BuilderBase<BUILDER extends Http1Config.BuilderBase<BUILDER, PROTOTYPE>, PROTOTYPE extends Http1Config>- Returns:
- maximum headers size
-
validatePrologue
public boolean validatePrologue()Disables query and fragment syntax validation when set tofalse; intended only for closed systems receiving trusted, valid request targets, as behavior for invalid input is unspecified. Validation of path is controlled byvalidatePath().- Returns:
- whether to validate prologue query and fragment
-
validatePath
public boolean validatePath()Whether to validate path characters and HTTP/1.1 request-target forms.- Returns:
- whether to validate path
-
continueImmediately
public boolean continueImmediately()When true WebServer answers to expect continue with 100 continue immediately, not waiting for user to actually request the data.- Returns:
- if
trueanswer with 100 continue immediately after expect continue
-
requestedUriDiscovery
Requested URI discovery settings.- Returns:
- settings for computing the requested URI
-
sendListeners
Connection send event listeners for HTTP/1.1.- Returns:
- send event listeners
-
receiveListeners
Connection receive event listeners for HTTP/1.1.- Returns:
- receive event listeners
-
altSvc
-
compositeSendListener
A single send listener, this value is computed.- Returns:
- send listener
-
compositeReceiveListener
A single receive listener, this value is computed.- Returns:
- receive listener
-
receiveLog
Deprecated, for removal: This API element is subject to removal in a future version.Logging of received packets. Uses trace and debug levels on logger ofHttp1LoggingConnectionListenerwith suffix of.recv`.- Returns:
trueif logging should be enabled for received packets,falseif no logging should be done
-
sendLog
Deprecated, for removal: This API element is subject to removal in a future version.Logging of sent packets. Uses trace and debug levels on logger ofHttp1LoggingConnectionListenerwith suffix of.send`.- Returns:
trueif logging should be enabled for sent packets,falseif no logging should be done
-
toString
- Overrides:
toStringin classHttpConfig.BuilderBase<BUILDER extends Http1Config.BuilderBase<BUILDER, PROTOTYPE>, PROTOTYPE extends Http1Config>
-
preBuildPrototype
protected void preBuildPrototype()Handles providers and decorators.- Overrides:
preBuildPrototypein classHttpConfig.BuilderBase<BUILDER extends Http1Config.BuilderBase<BUILDER, PROTOTYPE>, PROTOTYPE extends Http1Config>
-
validatePrototype
protected void validatePrototype()Validates required properties.- Overrides:
validatePrototypein classHttpConfig.BuilderBase<BUILDER extends Http1Config.BuilderBase<BUILDER, PROTOTYPE>, PROTOTYPE extends Http1Config>
-
HttpConfig.BuilderBase.log()